#define __NEW_STARLET
#include <syidef.h>
#include <stdlib.h>
#include <starlet.h>
#include <iledef.h>
#include <stdio.h>
#include <descrip.h>
#include <lib$routines.h>
#include <iosbdef.h>
#include <iccdef.h>

#include <ssdef.h>
#include <stsdef.h>
#include <iosbdef.h>
#include <iodef.h>

#include <string.h>

#define check(STS) if(!$VMS_STATUS_SUCCESS(STS)) sys$exit(STS)
#define MAX_NODE_NAME 15
#define MAX_BUFF 1000
#define NUM_MSGS 1000000

int  main(int argc,char **args) {
  int         status;
  int         i;
  int         a_handle;
  int         c_handle;
  unsigned short   channel;
  int         acc_len;
  IOSB        iosb;
  char        info[MAX_BUFF];
  static char node[MAX_NODE_NAME];
  char        task[256];
  $DESCRIPTOR (node_pmt, "Server node: ");
  struct dsc$descriptor_s r_node =
  {sizeof (node),
   DSC$K_DTYPE_T, DSC$K_CLASS_S, node};
  struct dsc$descriptor_s r_task =
  {sizeof (task),
   DSC$K_DTYPE_T, DSC$K_CLASS_S, task};

  if (argc < 2) {
    /* Get remote node name to connect with. */
    status = lib$get_input (&r_node, &node_pmt, &r_node.dsc$w_length);
    check (status);
    node[r_node.dsc$w_length] = '\0';
  } else {
    strcpy(node, args[1]);
    r_node.dsc$w_length = strlen(node);
  }

  strcpy(task, node);
  strcat(task, "::\"task=testperf\"");
  r_task.dsc$w_length = strlen(task);

  /* Connect. */
  printf ("connect request.\n");
  status = sys$assign (
               &r_task, 
               &channel, 
               0, 
               0, 
               0);
  check (status);

  status = lib$init_timer(0);
  check (status);

  /* Accept and display the first NUM_MSGS messages sent to us. */
  for (i = 0; i < NUM_MSGS; i++) {
    status = sys$qiow(0, channel, IO$_READVBLK, &iosb, 0, 0, 
		      &info, sizeof(info), 0, 0, 0, 0);
    check (status);
    check (iosb.iosb$w_status);
/*
    printf ("Read %d bytes\n", icc_iosb.ios_icc$l_rcv_len);
    printf ("Read \"%s\"\n", info);
*/
  }

  status = lib$show_timer(0, 0, 0, 0);
  check (status);

  status = sys$dassgn(channel);
  check (status);

  return (EXIT_SUCCESS);
}
